#!/usr/bin/perl

######################################################################
#                                                                    #
#  Dogsbody's Bandwidth Script for the Raq                           #
#  Version 1.04                                                      #
#  Lasted Edited on 30 Sep 2004                                      #
#  Contact Dogsbody at dan@dogsbody.org                              #
#                                                                    #
#  Add the standard template to the HTML pages on this site.         #
#                                                                    #
######################################################################
#                         EDIT BETWEEN HERE                          #
######################################################################

# You shouldn't need to change this, this is where the file is on a Raq4
# Please tell me if there are equivilent files on the other Raq's.
$statsfileone = "/home/.cobalt/report/stats.tab";

# The stats file above is system generated and contains data for web, 
# ftp & mail.  I also do audio video streaming and create another stats 
# file in the same format with the streaming stats for each site.
$statsfiletwo = "/dev/null";

# The default number of months to show (maximum of 12).
$monthstoshow = "6";

# Set the colours of the pages returned by the script.
$bodyback = "#ccccff";    # The colour of the background.
$bodytext = "#000000";    # The colour of the text.
$bodylink = "#0000ff";    # The colour of the hyperlinks.

# Cell highlighting ONE (This must be the higher of the two warnings)
$onewarning = "1024";     # Number in Mb
$onewarncol = "#ff0000";  # Colour to highlight the cell

# Cell highlighting TWO
$twowarning = "512";      # Number in Mb
$twowarncol = "#ffff00";  # Colour to highlight the cell

######################################################################
#                              AND HERE                              #
######################################################################

$script = $ENV{SCRIPT_NAME};
$cgi_user = $ENV{REMOTE_USER};
use CGI;
$cgi = new CGI();
$cgi_site = $cgi->param('site');
$cgi_date = $cgi->param('date');
$cgi_months = $cgi->param('months');


&readdata();
&checkdata();
&lockuser();
if ($cgi_site)
 {
 &header("Bandwidth for $cgi_site");
 &showonesite();
 }
else
 {
 &header("Bandwidth per Site for $hostname");
 &showallsites();
 }
&footer();
exit;


sub lockuser
{
my ($one,$two,$thr);
if ($cgi_user ne "" && $cgi_user ne "admin")
 {
 # The only way I could think of to work out the sites *name* from a user name.
 # If anyone has any better ideas please mail me.
 open(VIRTUSERTABLE,"/etc/mail/virtusertable") || &error("Cant open /etc/mail/virtusertable");
 while (<VIRTUSERTABLE>)
  {
  chomp;
  ($one,$two,$thr) = /^(.*?)\@(.*?)\t(.*?)$/;
  if ($one eq $cgi_user && $thr eq $cgi_user)
   {$cgi_site = $two;}
  }
 close(VIRTUSERTABLE);
 }
}


sub showonesite
{
my($date,$datatype,$line,@dataline,$total,$year,$month);
my(@months) = ('Null','Jan','Feb','Mar','Apr','May','Jun','Jul', 'Aug','Sep','Oct','Nov','Dec');
print "<table border=1>\n";
print "<tr><th>Data Type</th>";
foreach $date (@datelist)
 {
 ($year,$month) = split(/-/,$date,2);
 print "<th> $months[$month] $year </th>";
 }
print "</tr>\n";
foreach $datatype (@datatypes)
 {
 printf("<tr><td> <b>%s - Count</b> </td>",ucfirst($datatype));
 foreach $date (@datelist)
  {
  ($year,$month) = split(/-/,$date,2);
  $total = "0";
  foreach $line (@data)
   {
   @dataline = split(/\t/,$line);
   if ($dataline[0] eq $cgi_site && $dataline[1] eq $datatype && $dataline[2] eq $year && $dataline[3] eq $month)
    {$total = $total + $dataline[4];}
   }
  if ($total eq "0")
   {print "<td align=center> - </td>";}
  else
   {print "<td align=center> $total  </td>";}
  }
 print "</tr>\n";
 printf("<tr><td> <b>%s - Transfer</b> </td>",ucfirst($datatype));
 foreach $date (@datelist)
  {
  ($year,$month) = split(/-/,$date,2);
  $total = "0";
  foreach $line (@data)
   {
   @dataline = split(/\t/,$line);
   if ($dataline[0] eq $cgi_site && $dataline[1] eq $datatype && $dataline[2] eq $year && $dataline[3] eq $month)
    {
    $total = $total + $dataline[5];
    $mnthtot{$date} = $mnthtot{$date} + $dataline[5];
    }
   }
  if ($total eq "0")
   {print "<td align=center> - </td>";}
  else
   {
   $total = &humanreadable($total);
   print "<td align=right> $total </td>";
   }
  }
 print "</tr>\n";
 }
print "<tr><th>Totals</th>";
foreach $date (@datelist)
 {
 if ($mnthtot{$date})
  {
  $mnthtot{$date} = &humanreadable($mnthtot{$date});
  print "<th> $mnthtot{$date} </th>";
  }
 else
  {print "<th> - </th>";}
 }
print "</tr>\n";
print "</table>\n";
if ($cgi_user eq "" || $cgi_user eq "admin")
 {
 print qq!
 <form action="$script" method="GET">
 <input type="hidden" name="months" value="$cgi_months">
 <input type="hidden" name="date" value="$cgi_date">
 <input type="submit" value=" View bandwidth for all sites ">
 </form>
 !;
 }
}


sub showallsites
{
my($date,$site,$line,@dataline,$total,$year,$month);
my(@months) = ('Null','Jan','Feb','Mar','Apr','May','Jun','Jul', 'Aug','Sep','Oct','Nov','Dec');
print "<b>Click on a site name to see the breakdown for that site.</b></p>\n";
print "<p><table border=1>\n";
print "<tr><th>Site Name</th>";
foreach $date (@datelist)
 {
 ($year,$month) = split(/-/,$date,2);
 print "<th> $months[$month] $year </th>";
 }
print "</tr>\n";
foreach $site (@sitelist)
 {
 print "<tr><td> <b><a href=\"$script?months=$cgi_months&date=$cgi_date&site=$site\">$site</a></b> </td>";
 foreach $date (@datelist)
  {
  ($year,$month) = split(/-/,$date,2);
  $total = "0";
  foreach $line (@data)
   {
   @dataline = split(/\t/,$line);
   if ($dataline[0] eq $site && $dataline[2] eq $year && $dataline[3] eq $month)
    {
    $total = $total + $dataline[5];
    $mnthtot{$date} = $mnthtot{$date} + $dataline[5];
    }
   }
  if ($total eq "0")
   {print "<td align=center> - </td>";}
  elsif ($site eq "Total")
   {
   $total = &humanreadable($total);
   print "<td align=right> <b>$total</b> </td>";
   }
  elsif ($total > $onewarning)
   {
   $total = &humanreadable($total);
   print "<td align=right bgcolor=$onewarncol> <b>$total</b> </td>";
   }
  elsif ($total > $twowarning)
   {
   $total = &humanreadable($total);
   print "<td align=right bgcolor=$twowarncol> <b>$total</b> </td>";
   }
  else
   {
   $total = &humanreadable($total);
   print "<td align=right> $total </td>";
   }
  }
 print "</tr>\n";
 }
print "<tr><th>Totals</th>";
foreach $date (@datelist)
 {
 if ($mnthtot{$date})
  {
  $mnthtot{$date} = &humanreadable($mnthtot{$date});
  print "<th> $mnthtot{$date} </th>";
  }
 else
  {print "<th> - </th>";}
 }
print "</tr>\n";
print "</table>\n";
$onewarning = &humanreadable($onewarning);
$twowarning = &humanreadable($twowarning);
print qq!
<p><table border=1>
<tr><td bgcolor="$onewarncol" width="10"> </td><td> = Data over $onewarning</td></tr>
<tr><td bgcolor="$twowarncol" width="10"> </td><td> = Data over $twowarning</td></tr>
</table></p>
!;
}


sub humanreadable
{
my($size) = $_[0];
if ($size >= 1073741824) # 1024 x 1024 x 1024
 {
 $size = sprintf("%.1f",$size/1073741824);
 $size = $size . " Gb";
 }
elsif ($size >= 1048576) # 1024 x 1024
 {
 $size = sprintf("%.1f",$size/1048576);
 $size = $size . " Mb";
 }
elsif ($size >= 1024)
 {
 $size = sprintf("%.1f",$size/1024);
 $size = $size . " Kb";
 }
else
 {
 $size = $size . " b";
 }
return($size);
}


sub checkdata
{
my($line,@dataline,@temp,%temp,$cgidategood,@timenow,$cgi_year,$cgi_month,$temp_year,$temp_month);
foreach $line (@data)
 {
 @dataline = split(/\t/,$line);
 push(@alldates,"$dataline[2]-$dataline[3]");
 if ("$dataline[2]-$dataline[3]" eq $cgi_date)
  {$cgidategood = "yes";}
 if ($dataline[0] eq $cgi_site)
  {$cgisitegood = "yes";}
 }
if ($cgi_site ne "" && $cgisitegood eq "")
 {$cgi_site = "";}
if ($cgi_date eq "" || $cgidategood eq "")
 {
 @timenow = localtime(time);
 $timenow[4]++;
 if ($timenow[4] < 10) {$timenow[4] = "0$timenow[4]";}
 $timenow[5] = $timenow[5] + 1900;
 $cgi_date = $timenow[5] . "-" . $timenow[4];
 }
if ($cgi_months > 12) {$cgi_months = "12";}
if ($cgi_months eq "") {$cgi_months = $monthstoshow;}
($cgi_year,$cgi_month) = split(/-/,$cgi_date,2);
for ($i = 0;$i <= $cgi_months-1; $i++)
 {
 $temp_month = $cgi_month - $i;
 $temp_year = $cgi_year;
 if ($temp_month < 1)
  {
  $temp_year = $cgi_year - 1;
  $temp_month = $temp_month + 12;
  }
 if ($temp_month < 10) {$temp_month = "0$temp_month";}
 push(@datelist,"$temp_year-$temp_month");
 }
@datelist = sort @datelist;
@temp{@alldates} = ();
@alldates = sort {$b cmp $a} keys %temp;
}


sub readdata
{
my(@dataline,@temp,%temp);
# Read Stats file one
open(STATSFILEONE,"$statsfileone") || &error("Cant open $statsfileone");
while (<STATSFILEONE>)
 {
 chomp;
 @dataline = split(/\t/);
 if ($dataline[0] ne "Total")
  {
  push(@data,$_);
  push(@sitelist,$dataline[0]);
  push(@datatypes,$dataline[1]);
  }
 }
close(STATSFILEONE);
# Read Stats file two
open(STATSFILETWO,"$statsfiletwo") || &error("Cant open $statsfiletwo");
while (<STATSFILETWO>)
 {
 chomp;
 @dataline = split(/\t/);
 if ($dataline[0] ne "Total")
  {
  push(@data,$_);
  push(@sitelist,$dataline[0]);
  push(@datatypes,$dataline[1]);
  }
 }
close(STATSFILETWO);
# Create a unique list of sites
@temp{@sitelist} = ();
@sitelist = sort keys %temp;
# Create a unique list of data types
%temp = ();
@temp{@datatypes} = ();
@datatypes = sort keys %temp;
# Convert Mb to bytes
$onewarning = $onewarning * 1048576;
$twowarning = $twowarning * 1048576;
# Grab the systems hostname
use Socket;
use Sys::Hostname;
$hostname = hostname();
}


sub header
{
my($header) = $_[0];
my(@months) = ('Null','Jan','Feb','Mar','Apr','May','Jun','Jul', 'Aug','Sep','Oct','Nov','Dec');
my($date,$year,$month);
print "Content-type: text/html\n\n";
print qq!
<html>
<head>
<title>$header</title>
</head>
<body bgcolor="$bodyback" text="$bodytext" link="$bodylink" alink="#FF0000" vlink="$bodylink" >
<center>
<p><font size=6><strong>$header</strong></font></p>
<p>These statistics are updated once a day.</p>
<p><form action="$script" method="GET">
<input type="hidden" name="site" value="$cgi_site">
Show <select name="months">
!;
for ($i = 1;$i <= 12; $i++)
 {
 ($year,$month) = split(/-/,$date,2);
 if ($i eq $cgi_months)
  {print "<option selected value=$i> $i </option>\n";}
 else
  {print "<option value=$i> $i </option>\n";}
 }
print qq!
</select> month(s) data up to <select name="date">
!;
foreach $date (@alldates)
 {
 ($year,$month) = split(/-/,$date,2);
 if ($date eq $cgi_date)
  {print "<option selected value=$date> $months[$month] $year </option>\n";}
 else
  {print "<option value=$date> $months[$month] $year </option>\n";}
 }
print qq!
</select> <input type="submit" value=" Submit ">
</form></p>
<p>
!;
}


sub footer
{
## Please don't remove this line, it's not much to ask for a free script!  :-)
## I have even been nice so that the line won't show when users login!
if ($cgi_site eq "")
 {print "</p><p><small>Generated by <a href=\"http://www.dogsbody.org/\">Dogsbody's</a> Bandwidth Script v1.04</small>";}
print qq!
</p>
</center>
</body>
</html>
!;
}

